#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <gtk/gtk.h>
#include <cups/cups.h>
#include <stdio.h>
#include <string.h>

#include "callbacks.h"
#include "interface.h"
#include "support.h"

#include "coda.h"
#include "docklet.h"


void
on_esci1_activate                      (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
  if(system_tray==0)
  {
	  gqueuepref_write (&pref);
	  exit(0);
  }
  else
  {
	  docklet_toggle();
  }
}


void
on_elimina1_activate                   (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
	GtkButton       *button;
	
	on_buttonElimina_clicked(button,user_data);
}


void
on_about1_activate                     (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{	
  info = create_Info ();	
  gtk_widget_show (info);
}


int
queue_refresh				( void )

{
	int i,printing,num_jobs,num_dests,mypid,ID;
	cups_job_t *jobs;
	cups_dest_t *dests,*dest;
	gchar  *mydest, *lock_file_name,*myhome,stringa[64],*Stampante,stato[20];
	GtkTreeIter   iter,iter2;  
	GtkTreeSelection *select;
    GtkTreeModel *model;
	FILE *lock_file_descriptor;
	
	// lock file exist?
	myhome = getenv ("HOME");
	mypid=getpid();
	lock_file_name = g_strdup_printf ("%s/%s.%d", myhome, ".gqueue-lock",mypid);
	if((lock_file_descriptor = fopen(lock_file_name,"r"))==NULL)
	{
		// lock file not exists then I exit
	    exit(0);
	}
	fclose(lock_file_descriptor);
    g_free(myhome);
    g_free(lock_file_name);
	
	
	num_dests = cupsGetDests(&dests);
	dest      = cupsGetDest(NULL, NULL, num_dests, dests);
	  
	strncpy(stringa,gtk_entry_get_text (GTK_ENTRY(GTK_COMBO (lookup_widget ( GTK_WIDGET(FinestraPrincipale), "combo1" ))->entry)),63);
	stringa[63]='\n';
	
	mydest = g_strdup_printf ("%s", stringa);
	
	if ( !strcmp(stringa,_("Tutte le stampanti")))
	{
		mydest=NULL;
	}
	
	if ( !strcmp(stringa,_("Stampante di default")))
	{
		mydest=dest->name;
	}
	
	num_jobs = cupsGetJobs(&jobs, mydest, 0, 0);
	//printf("%d active job(s):\n", num_jobs);
	if (num_jobs == 0)
	{
	  if(system_tray==1) docklet_update_status((enum docklet_status)stopped);
	}
	
	// Salvo l'informazione sulla riga selezionata (da riselezionare dopo se ancora esistente)
	select = gtk_tree_view_get_selection (GTK_TREE_VIEW (tree));
	if (gtk_tree_selection_get_selected (select, &model, &iter2))
        {
                gtk_tree_model_get (model, &iter2, 0, &Stampante, -1);
			    gtk_tree_model_get (model, &iter2, 1, &ID, -1);
        }
	else
	{
		Stampante = NULL;
		ID=-1;
	}

	
	printing=0;
	gtk_list_store_clear(GTK_LIST_STORE(store));
	for (i = 0; i < num_jobs; i ++)
	{
		/*printf("%-16.16s %-6d %-12.12s %s (%s)\n", jobs[i].dest, jobs[i].id,
			 jobs[i].user, jobs[i].title,
			 jobs[i].state != IPP_JOB_PENDING ? "printing" : "pending");*/
		
		if(jobs[i].state==IPP_JOB_PENDING) {
		  strcpy(stato,_("In attesa"));			
		}
		else {
		  strcpy(stato,_("In stampa"));
		  printing=1;
		}
		gtk_list_store_insert (GTK_LIST_STORE(store), &iter,i);
        gtk_list_store_set (GTK_LIST_STORE(store), &iter,
											   STAMPANTE_COLUMN,jobs[i].dest,
											   ID_COLUMN,jobs[i].id,
											   UTENTE_COLUMN,jobs[i].user,
											   TITOLO_COLUMN,jobs[i].title,
											   STATO_COLUMN,stato,
											   -1);
		
		// Ripristina selezione
		if (jobs[i].id == ID && (!strcmp (jobs[i].dest, Stampante)))
		{	
			gtk_tree_selection_select_iter(select, &iter);
		}
	}
	
	if(system_tray==1 && printing==1) docklet_update_status((enum docklet_status)printing);
	if(system_tray==1 && printing==0) docklet_update_status((enum docklet_status)stopped);
	
	cupsFreeJobs(num_jobs, jobs);
	cupsFreeDests(num_dests, dests);
	g_free (Stampante);
	
	return(1);
}

void
combo_init				( void )

{
	
	GList *glist = NULL;
	cups_dest_t *dests,*dest;
	int num_dests,i;

	glist = g_list_append (glist, _("Stampante di default"));
	glist = g_list_append (glist, _("Tutte le stampanti"));
	
	num_dests = cupsGetDests(&dests);
	dest      = cupsGetDest(NULL, NULL, num_dests, dests);
	
	for(i=0;i<num_dests;i++)
	{
		glist = g_list_append (glist,dests[i].name);
		gtk_combo_set_popdown_strings (GTK_COMBO (lookup_widget ( GTK_WIDGET(FinestraPrincipale), "combo1" )), glist);
	}
	
		g_list_free(glist);
		cupsFreeDests(num_dests, dests);
	
}



void
on_buttonEsci_clicked                  (GtkButton       *button,
                                        gpointer         user_data)
{
	if(system_tray==0)
  	{
	  gqueuepref_write (&pref);
	  exit(0);
	 
  	}
	else
  {
	  docklet_toggle();
  }
}



void
on_buttonElimina_clicked               (GtkButton       *button,
                                        gpointer         user_data)
{
	GtkTreeIter iter;
    GtkTreeModel *model;
    gchar *Stampante;
	int ID;
	GtkTreeSelection *select;
	

    select = gtk_tree_view_get_selection (GTK_TREE_VIEW (tree));

        if (gtk_tree_selection_get_selected (select, &model, &iter))
        {
                gtk_tree_model_get (model, &iter, 0, &Stampante, -1);
			    gtk_tree_model_get (model, &iter, 1, &ID, -1);

				cupsCancelJob(Stampante, ID);   
			
                g_free (Stampante);
				queue_refresh();
        }

}


void
on_buttonInfo_clicked                  (GtkButton       *button,
                                        gpointer         user_data)
{
	  info = create_Info ();	
	  gtk_widget_show (info);
}



void
on_buttonChiudi_clicked                (GtkButton       *button,
                                        gpointer         user_data)
{
  gtk_widget_destroy(info);
}


void
on_combo_entry1_changed                (GtkEditable     *editable,
                                        gpointer         user_data)
{
	queue_refresh();
}


gboolean
on_gqueue_delete_event                 (GtkWidget       *widget,
                                        GdkEvent        *event,
                                        gpointer         user_data)
{
  if(system_tray==1)
  {
	  docklet_toggle();
	  return TRUE;
  }
  else
  {
	  exit(0);
	  return FALSE;
  }
}


gboolean
on_Info_delete_event                   (GtkWidget       *widget,
                                        GdkEvent        *event,
                                        gpointer         user_data)
{
  gtk_widget_destroy(info);
  return FALSE;
}



gboolean
on_gqueue_window_state_event           (GtkWidget       *widget,
                                        GdkEvent        *event,
                                        gpointer         user_data)
{ 
	if(semaforo_window_state_event==0)
	{
	
		if( system_tray==1
		    && event->window_state.changed_mask == GDK_WINDOW_STATE_ICONIFIED
	        && event->window_state.new_window_state == GDK_WINDOW_STATE_ICONIFIED )
		{
			semaforo_window_state_event=1;
			gtk_widget_hide (FinestraPrincipale);
		}
    }
	else semaforo_window_state_event=0; 
}

void
system_tray_on()
{
	if(system_tray==0)
	{
		system_tray=1;
		docklet_register_icon_factory();
		docklet_create(FinestraPrincipale);
		docklet_toggle();
	}
}

void
system_tray_off()
{
	if(system_tray==1)
	{
		system_tray=0;
		docklet_delete();
	}
}


void
on_in_system_tray_activate             (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
    if(semaforo==0)
	{
		if(system_tray==0)
			system_tray_on();
		else
			system_tray_off();
	
		// Save pref.
		pref.system_tray = system_tray;
		gqueuepref_write (&pref);
    }
}




gboolean
on_gqueue_destroy_event                (GtkWidget       *widget,
                                        GdkEvent        *event,
                                        gpointer         user_data)
{
  return FALSE;
}

